import { Vec3 } from "../../src/math/Vec3";
export declare const wgs84OneOverRadii: Vec3;
export declare const wgs84OneOverRadiiSquared: Vec3;
/**
 * 地理坐标
 */
export declare class Cartographic {
    longitude: number;
    latitude: number;
    height: number;
    /**
     * 单位都是弧度
     * @param longitude  经度
     * @param latitude 纬度
     * @param height 海拔
     */
    constructor(longitude?: number, latitude?: number, height?: number);
    static fromRadians(longitude?: number, latitude?: number, height?: number, result?: Cartographic): Cartographic;
    static fromDegrees(longitude?: number, latitude?: number, height?: number, result?: Cartographic): Cartographic;
}
