"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EllipsoidTerrainProvider = void 0;
var HeightmapTerrainData_1 = require("src-gis/core/HeightmapTerrainData");
var ellipsoid_1 = require("../math/ellipsoid");
var GeographicTilingScheme_1 = require("../scene/GeographicTilingScheme");
var EllipsoidTerrainProvider = /** @class */ (function () {
    function EllipsoidTerrainProvider(options) {
        var _a;
        if (!this._tilingScheme) {
            this._tilingScheme = new GeographicTilingScheme_1.GeographicTilingScheme({
                ellipsoid: (_a = options.ellipsoid) !== null && _a !== void 0 ? _a : ellipsoid_1.Ellipsoid.WGS84,
            });
        }
    }
    EllipsoidTerrainProvider.prototype.requestTileGeometry = function (x, y, level, request) {
        var width = 16;
        var height = 16;
        return new Promise(function (resolve, reject) {
            resolve(new HeightmapTerrainData_1.HeightmapTerrainData({
                buffer: new Uint8Array(width * height),
                width: width,
                height: height,
            }));
        });
    };
    return EllipsoidTerrainProvider;
}());
exports.EllipsoidTerrainProvider = EllipsoidTerrainProvider;
