import { Cartographic } from "src-gis/math/Cartographic";
import { Ellipsoid } from "src-gis/math/ellipsoid";
import { GVec3 } from "src-gis/math/GVec3";
import { Ray } from "src/struct/3d/Ray";
import { GlobeSurfaceShaderSet } from "./GlobeSurfaceShaderSet";
import { ImageryLayerCollection } from "./ImageryLayerCollection";
import { QuadtreePrimitive } from "./quadtree_primitive";
export declare class Globe {
    ellipsoid: Ellipsoid;
    /**
     *   地形提供器
     */
    private _terrainProvider;
    /**
     *   图层集合
     */
    imageLayers: ImageryLayerCollection;
    /**
     *  地形块存数量
     */
    tileCacheSize: number;
    loadingDescendantLimit: number;
    /**
     * 显示水的效果
     */
    showWaterEffect: boolean;
    _surface: QuadtreePrimitive;
    _surfaceShaderSet: GlobeSurfaceShaderSet;
    showSkirts: boolean;
    constructor(ellipsoid?: Ellipsoid);
    pick(rat: Ray, scene: any, result: GVec3): void;
    getHeight(cartographic: Cartographic): number | undefined;
    get tilesLoaded(): boolean;
}
